package com.smppw.common.pojo;

import lombok.Data;

import java.util.Date;

/**
    * 交易日
    */
@Data
public class IndexesTradeDateDo {
    /**
    * 主键ID
    */
    private Integer id;

    /**
    * 指数代码
    */
    private String indexCode;

    /**
    * 日期
    */
    private String tradeDate;

    /**
    * 截止年份
    */
    private String endYear;

    /**
    * 全年的第几周
    */
    private Integer weekOfYear;

    /**
    * 年周
    */
    private String yearWeek;

    /**
    * 星期，周一为1
    */
    private Integer dayOfWeek;

    /**
    * 周的开始日期
    */
    private Date weekBegin;

    /**
    * 周的结束日期
    */
    private Date weekEnd;

    /**
    * 上一周所在的年
    */
    private String preYear;

    /**
    * 上一周
    */
    private Byte preWeek;

    /**
    * 是否为节假日 0 工作日 1 节假日
    */
    private Integer isholiday;

    /**
    * 是否周最后交易日：1-是，2-否
    */
    private Integer isWeekend;

    /**
    * 是否月最后交易日：1-是，2-否
    */
    private Integer isMonthend;

    /**
    * 是否季最后交易日：1-是，2-否
    */
    private Integer isQuarterend;

    /**
    * 是否年最后交易日：1-是，2-否
    */
    private Integer isYearend;

    /**
    * 记录有效性 1 有效 0 无效
    */
    private Integer isvalid;

    /**
    * 创建人id
    */
    private Integer creatorid;

    /**
    * 创建时间
    */
    private Date createtime;

    /**
    * 更新人id
    */
    private Integer updaterid;

    /**
    * 更新时间
    */
    private Date updatetime;

    /**
    * 年月
    */
    private String yearmonth;
}